#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <io.h>
/* 
	detab.c - get rid of unnecessary tab characters
*/
char  *progname;  /* name of this program */
char  *filename;  /* name of file to dump */
/*----------------------------------------------------------------------*/
/* 
	usage() - Display usage information
*/
void
usage()
{
	fprintf(stderr, "Usage: %s filename\n", progname);
} /* end of usage() */
/*----------------------------------------------------------------------*/
/* 
	parse() - Command line parser.
*/
void
parse(argc, argv)
	int argc;
	char *argv[];
{
	progname = argv[0];
	if (argc < 2) {
		usage();
		exit(1);
	}
	filename = argv[1];
	if (strcmp(filename, "") == 0) {
		fprintf(stderr,"%s: you must specify a file name\n",progname);
		usage();
		exit(1);
	}
} /* end of parse() */
int
main(argc,argv)
int argc;
char *argv[];
{
	int i,j,tabs,linesize,lines;
    char    *s;
	FILE *fp;    /* file pointer of the file */
	unsigned char line[4096]; /* one line of text */
	/* parse the command line */
	parse(argc,argv);
	/* open the file */
	fp = fopen(filename,"r");
	if (fp == 0) {
		fprintf(stderr, "%s: error opening file '%s'\n",
			progname,filename);
		exit(1);
	} /* end of opening the file */
    memset(line,0,sizeof(line));
	j = 0;
    lines=0;
    tabs=0;
	while ((s = fgets(line,sizeof(line),fp)) != 0) {
        linesize = strlen(line);
        i = 0;
        /* look for the first non-whitespace character in the line */
        while (isspace(line[i]) && (i < linesize)) i++;
        if (i >= linesize) continue;
        /* i is now at the first non-whitespace character */
        for (;i<linesize; i++) {
            if (line[i] == '\t') {
                line[i] = ' ';
                tabs++;
            }
        }
        write(1,line,linesize);
        memset(line,0,sizeof(line));
	}
	fprintf(stderr,"Found %d tabs\n",tabs);
    return(0);
} /* end of main() */
